package com.ruoyi.gysl.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.gysl.entity.Pjpz;
import com.ruoyi.gysl.entity.Xmpjqd;
import com.ruoyi.gysl.entity.request.XmpjqdPageReq;
import com.ruoyi.gysl.entity.response.XmhxDetail.XmhxDetail;
import com.ruoyi.gysl.entity.response.XmhxResponse;
import com.ruoyi.gysl.entity.response.XmpjqdOneResponse;
import com.ruoyi.gysl.mapper.XmpjqdMapper;
import com.ruoyi.gysl.service.PjpzService;
import com.ruoyi.gysl.service.XmpjqdService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;

/**
 * 项目评价清单(Xmpjqd)表服务实现类
 *
 * @author makejava
 * @since 2025-03-22 09:22:33
 */
@Service("xmpjqdService")
public class XmpjqdServiceImpl extends ServiceImpl<XmpjqdMapper, Xmpjqd> implements XmpjqdService {

    @Resource
    private XmpjqdMapper xmpjqdMapper;

    @Resource
    private PjpzService pjpzService;

    /**
     * 分页查询所有目录
     *
     * @param page 分页对象
     * @return 所有数据
     */
    @Override
    public Page<Xmpjqd> page(Page<Xmpjqd> page, XmpjqdPageReq req) {
        return xmpjqdMapper.page(page, req);
    }

    /**
     * 通过主键查询单条项目评价清单
     *
     * @param id 主键
     * @return 单条数据
     */
    @Override
    public List<XmpjqdOneResponse> selectOnePj(Serializable id) {
        List<XmpjqdOneResponse> xmpjqdOneResponses = xmpjqdMapper.selectOnePj(id);
        List<Pjpz> list = pjpzService.list();
        list.forEach(x -> {
            if (!"总投资额".equals(x.getPjys())) {
                XmpjqdOneResponse xmpjqdOneResponse = new XmpjqdOneResponse();
                xmpjqdOneResponse.setYsmc(x.getPjys());
                xmpjqdOneResponses.add(xmpjqdOneResponse);
            }
        });
        return xmpjqdOneResponses;
    }

    /**
     * 通过主键查询单条项目画像
     *
     * @param id 主键
     * @return 单条数据
     */
    @Override
    public List<XmhxResponse> oneXmhx(Serializable id) {
        List<XmhxResponse> obj = new ArrayList<>();
        XmhxResponse xr = new XmhxResponse();
        xr.setType(1);
        xr.setList(xmpjqdMapper.maxXmhx());

        XmhxResponse xr1 = new XmhxResponse();
        xr1.setType(2);
        xr1.setList(xmpjqdMapper.oneXmhx(id));


        XmhxResponse xr2 = new XmhxResponse();
        xr2.setType(3);
        List<BigDecimal> bigDecimals = xmpjqdMapper.zwsXmhx();
        List<XmhxDetail> a1 = getXmhxDetails(bigDecimals,"总投资额");
        xr2.setList(a1);
        obj.add(xr);
        obj.add(xr1);
        obj.add(xr2);
        return obj;
    }

    private static List<XmhxDetail> getXmhxDetails(List<BigDecimal> bigDecimals,String content) {
        List<XmhxDetail> a1 = new ArrayList<>();
        XmhxDetail xmhxDetail = new XmhxDetail();
        xmhxDetail.setYsmc(content);
        int length = bigDecimals.size();
        int middleIndex = length / 2;
        // 根据奇偶性计算中位数
        if (length % 2 == 1) {
            xmhxDetail.setPjpm(String.valueOf(bigDecimals.get(middleIndex)));
        } else {
            BigDecimal lower = bigDecimals.get(middleIndex - 1);
            BigDecimal upper = bigDecimals.get(middleIndex);
            xmhxDetail.setPjpm(
                    String.valueOf(
                            lower.add(upper)
                                    .divide(BigDecimal.valueOf(2), 2, RoundingMode.HALF_UP)  // 2 表示保留两位小数
                    )
            );
        }
        a1.add(xmhxDetail);
        return a1;
    }
}

